'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _desktopComponent = require('../../desktop-component');

var _desktopComponent2 = _interopRequireDefault(_desktopComponent);

var _os = require('../../os');

var _row = require('./row/row');

var _row2 = _interopRequireDefault(_row);

var _rowWrapper = require('./row/row-wrapper');

var _rowWrapper2 = _interopRequireDefault(_rowWrapper);

var _label = require('../../label/label.osx/label');

var _label2 = _interopRequireDefault(_label);

var _label3 = require('../../label/label.windows/label');

var _label4 = _interopRequireDefault(_label3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  table: {
    userSelect: 'none',
    cursor: 'default',
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'center'
  },

  labelRowOsx: {
    marginBottom: '20px'
  },

  labelRowWin: {
    marginBottom: '10px'
  }
};

var Form = (0, _desktopComponent2.default)(_class = (_temp2 = _class2 = function (_Component) {
  _inherits(Form, _Component);

  function Form() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Form);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Form)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.labels = [], _this.rows = [], _this.submit = function (event) {
      event.preventDefault();
      if (_this.props.onSubmit) {
        _this.props.onSubmit();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Form, [{
    key: 'registerRow',
    value: function registerRow(row) {
      this.rows = [].concat(_toConsumableArray(this.rows), [row]);
      if ((0, _os.get)() === 'win') {
        this.applyWithToRows();
      }
    }
  }, {
    key: 'registerLabel',
    value: function registerLabel(label) {
      this.labels = [].concat(_toConsumableArray(this.labels), [label]);
      if ((0, _os.get)() === 'osx') {
        this.applyWithToLabels();
        this.applyWithToRows();
      }
    }
  }, {
    key: 'applyWithToLabels',
    value: function applyWithToLabels() {
      var maxWidth = 0;
      var labels = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.labels[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var label = _step.value;

          label = (0, _reactDom.findDOMNode)(label);
          labels = [].concat(_toConsumableArray(labels), [label]);
          maxWidth = label.offsetWidth > maxWidth ? label.offsetWidth : maxWidth;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = labels[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var label = _step2.value;

          label.style.width = maxWidth + 1 + 'px';
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }, {
    key: 'applyWithToRows',
    value: function applyWithToRows() {
      var maxWidth = 0;
      var rows = [];

      for (var prop in this.refs) {
        if (this.refs.hasOwnProperty(prop)) {
          var row = (0, _reactDom.findDOMNode)(this.refs[prop]);
          rows = [].concat(_toConsumableArray(rows), [row]);
          maxWidth = row.offsetWidth > maxWidth ? row.offsetWidth : maxWidth;
        }
      }

      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = rows[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var row = _step3.value;

          row.style.width = maxWidth + 'px';
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var onSubmit = _props.onSubmit;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['onSubmit', 'children', 'style']);

      var componentStyle = _extends({}, styles.table, style);

      children = _react.Children.map(children, function (element, index) {
        var isLast = index + 1 === _react.Children.count(children);
        if (isLast) {
          element = (0, _react.cloneElement)(element, {
            style: _extends({}, element.props.style, { marginBottom: '0' })
          });
        }

        if (element.type === _row2.default) {
          var ref = 'row-' + index;
          return _react2.default.createElement(
            _rowWrapper2.default,
            { ref: ref, style: style },
            (0, _react.cloneElement)(element, { form: _this2 })
          );
        } else if (element.type === _label2.default || element.type === _label4.default) {
          var ref = 'label-' + index;
          return _react2.default.createElement(
            _rowWrapper2.default,
            { ref: ref, style: (0, _os.get)() === 'win' ? styles.labelRowWin : styles.labelRowOsx },
            (0, _react.cloneElement)(element, { form: _this2 })
          );
        }
        return element;
      });

      return _react2.default.createElement(
        'form',
        _extends({
          onSubmit: this.submit,
          style: componentStyle
        }, props),
        children
      );
    }
  }]);

  return Form;
}(_react.Component), _class2.Row = _row2.default, _class2.propTypes = {
  onSubmit: _react.PropTypes.func
}, _temp2)) || _class;

exports.default = Form;